#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use DBI;
use CGI;
use acs;
use LWP 5.64;
use obbuild;

&get_setup;



#### GET CONFIG


my $num_children = 0; # number we have now
my $im_the_parent = 1; # is this process the parent?
my @kid_pid = (); # array of child PIDs






#### REMOVE OLD FILES IF ANY LEFT


opendir(DIR,"$data_dir");
@files = readdir(DIR);

foreach $filename (@files)
	{

	if (substr($filename, length($filename) - 3, 3) eq "llc")
		{
		unlink ("$data_dir/$filename");
		}
		elsif (substr($filename, length($filename) - 5, 5) eq "lclog")
		{
		unlink ("$data_dir/$filename");
		}
		elsif (substr($filename, length($filename) - 5, 5) eq "lcpid")
		{
		unlink ("$data_dir/$filename");
		}
		elsif (substr($filename, length($filename) - 6, 6) eq "lclog2")
		{
		unlink ("$data_dir/$filename");
		}
		
	}
closedir (DIR);

### CHMOD FILES TO 777


##### CONNECT DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }



##### OBTAIN ALL LINKS AND PLACE THEM IN TEXT FILES

$sql = "SELECT lnkid, cid, url FROM links";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
$rows = $sth->rows(); 


$cconf = acs::get_file_contents("$data_dir/crawler.cfg");  
($ver, $links_to_check_per_window, $frames, $timeout, $ssh_threads) = split (/\n/, $cconf);

if ($ssh_threads eq "") { $ssh_threads = 30; }

print "Opening $ssh_threads Threads\n\n";

$nr_segments = $ssh_threads;

$modp = ($rows / $nr_segments);


if ($modp =~ /\./)
	{
	($perfile, $tmp) = split(/\./, $modp);
	}
	else
	{
	$perfile = $modp;
	}

$perfile = $perfile + 10;

$pcount = 0;
$fcount = 1;


while ( @row = $sth->fetchrow() )
	{
	$lnr = $lnr . $row[0] . ":-:-:" . $row[1] . ":-:-:" . $row[2] . "\n"; 
	$pcount++;

	if ($pcount == $perfile)
		{
		open (FWR, "> $data_dir/$fcount.llc");
			print FWR $lnr;
		close (FWR);
		$lnr = "";
		$pcount = 0;
		$fcount++;
		}
	
	}

## WRITE REMAINING LINKS
open (FWR, "> $data_dir/$fcount.llc");
	print FWR $lnr;
close (FWR);

###########

#print "NUMBER OF FILES: $fcount <BR>";
#print "TOTAL LINKS: $rows <BR>";


$sth->finish;
$dbh->disconnect;





###### SPAWN CHILD PROCESSES (THREADS)


#$randomnumber = int(rand(999999)); 
#open (RND, "> $data_dir/$randomnumber.tmp");
#print RND "AA";
#close (RND);



my $browser = LWP::UserAgent->new;
$browser->timeout($timeout);
$browser->agent("Mozilla/4.0 (compatible; MSIE 5.5)"); 

for(my  $i = 1; $i < ($ssh_threads+1); $i++ ) 
	{

    if( my $p = fork() ) ### PARENT PROCESS
    {
        
        
        push( @kid_pid, $p ); # add to the array of child PIDs
        $num_children = $i + 1; # The loop starts at 0, so add 1 here
                                # (or, we could have started the loop
                                # at 1, used <= instead of <, not
                                # added anything here, and been more
                                # efficient but slightly less clear.

		 

    } 
    else ### CHILD PROCESS
    {
    $im_the_parent = 0; # We only want the original process

		

		$links_filename = $i . ".llc";
		open (LNKS, "$data_dir/$links_filename");
			while (defined($line=<LNKS>))
				{
					($lnkid, $cid, $url) = split (/:-:-:/, $line);
					$url =~ s/\n//gi;

					$response = $browser->head($url); # or die "Couldn't download";
					$status = $response->status_line;
					
					if ($response->is_success)
							{
							$tok = "OK";
							}
							else
							{
							$tok = "";
							}
					
						print "$url -> $status \n\n";
					
						$log_filename = $i . "llc.lclog";
						open (LOGG, ">> $data_dir/$log_filename");
						print LOGG $url . ":-:" . $lnkid . ":-:"  . $cid . ":-:" . "$status\n";
						close (LOGG);
					
				}
		close (LNKS);


		### PACK TO DB
		if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
		$dbh = DBI->connect($dsn, $db_username, $db_password);
		if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

		$progress = acs::get_file_contents("$data_dir/$log_filename"); 
		@plines = split (/\n/, $progress);

		foreach $pline (@plines)
			{
			($url, $lnkid, $cid, $status) = split (/:-:/, $pline);
			if (substr($status, 0, 3) ne "200")
				{
				$status =~ s/'/\\'/g;
				@sts = split (/ /, $status);
				
				$sql2 = "INSERT IGNORE INTO brokenlnks2 SET lnkid = '$lnkid', cid = '$cid',lnkproblem = '$status', problemid = '$sts[0]'";
				
				print "-->\n\n\n $sql2 \n\n\n";
				
				$sth = $dbh->prepare($sql2);
				$sth->execute;
				$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
				}
			} 

		$sth->finish;
		$dbh->disconnect;
        

              # to perform any actions meant for
              # the parent.
        last; # We want out of the loop so we don't also spawn
              # children within the loop.
    }

}


foreach $piditem (@kid_pid)
	{
	waitpid($piditem,0);
	}


print "Thread Ended....\n\n";



sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################



sub get_env
{
if ($ENV{'QUERY_STRING'} ne "") {
								$temp = $ENV{'QUERY_STRING'};
								}
								else
								{
								read(STDIN, $temp, $ENV{'CONTENT_LENGTH'});
								}

@pairs=split(/&/,$temp);
foreach $item(@pairs){
	($key,$content)=split (/=/,$item,2);
	$content=~tr/+/ /;
	$content=~ s/%(..)/pack("c",hex($1))/ge;
	$fields{$key}=$content;}

}
 